
/* auto-generated by gen_syscalls.py, don't edit */
#ifndef Z_INCLUDE_SYSCALLS_FLASH_H
#define Z_INCLUDE_SYSCALLS_FLASH_H


#ifndef _ASMLANGUAGE

#include <syscall_list.h>
#include <syscall_macros.h>

#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wstrict-aliasing"

#ifdef __cplusplus
extern "C" {
#endif

extern int z_impl_flash_read(struct device * dev, off_t offset, void * data, size_t len);
static inline int flash_read(struct device * dev, off_t offset, void * data, size_t len)
{
#ifdef CONFIG_USERSPACE
	if (z_syscall_trap()) {
		return (int) z_arch_syscall_invoke4(*(u32_t *)&dev, *(u32_t *)&offset, *(u32_t *)&data, *(u32_t *)&len, K_SYSCALL_FLASH_READ);
	}
#endif
	compiler_barrier();
	return z_impl_flash_read(dev, offset, data, len);
}


extern int z_impl_flash_write(struct device * dev, off_t offset, const void * data, size_t len);
static inline int flash_write(struct device * dev, off_t offset, const void * data, size_t len)
{
#ifdef CONFIG_USERSPACE
	if (z_syscall_trap()) {
		return (int) z_arch_syscall_invoke4(*(u32_t *)&dev, *(u32_t *)&offset, *(u32_t *)&data, *(u32_t *)&len, K_SYSCALL_FLASH_WRITE);
	}
#endif
	compiler_barrier();
	return z_impl_flash_write(dev, offset, data, len);
}


extern int z_impl_flash_erase(struct device * dev, off_t offset, size_t size);
static inline int flash_erase(struct device * dev, off_t offset, size_t size)
{
#ifdef CONFIG_USERSPACE
	if (z_syscall_trap()) {
		return (int) z_arch_syscall_invoke3(*(u32_t *)&dev, *(u32_t *)&offset, *(u32_t *)&size, K_SYSCALL_FLASH_ERASE);
	}
#endif
	compiler_barrier();
	return z_impl_flash_erase(dev, offset, size);
}


extern int z_impl_flash_write_protection_set(struct device * dev, bool enable);
static inline int flash_write_protection_set(struct device * dev, bool enable)
{
#ifdef CONFIG_USERSPACE
	if (z_syscall_trap()) {
		return (int) z_arch_syscall_invoke2(*(u32_t *)&dev, *(u32_t *)&enable, K_SYSCALL_FLASH_WRITE_PROTECTION_SET);
	}
#endif
	compiler_barrier();
	return z_impl_flash_write_protection_set(dev, enable);
}


extern int z_impl_flash_get_page_info_by_offs(struct device * dev, off_t offset, struct flash_pages_info * info);
static inline int flash_get_page_info_by_offs(struct device * dev, off_t offset, struct flash_pages_info * info)
{
#ifdef CONFIG_USERSPACE
	if (z_syscall_trap()) {
		return (int) z_arch_syscall_invoke3(*(u32_t *)&dev, *(u32_t *)&offset, *(u32_t *)&info, K_SYSCALL_FLASH_GET_PAGE_INFO_BY_OFFS);
	}
#endif
	compiler_barrier();
	return z_impl_flash_get_page_info_by_offs(dev, offset, info);
}


extern int z_impl_flash_get_page_info_by_idx(struct device * dev, u32_t page_index, struct flash_pages_info * info);
static inline int flash_get_page_info_by_idx(struct device * dev, u32_t page_index, struct flash_pages_info * info)
{
#ifdef CONFIG_USERSPACE
	if (z_syscall_trap()) {
		return (int) z_arch_syscall_invoke3(*(u32_t *)&dev, *(u32_t *)&page_index, *(u32_t *)&info, K_SYSCALL_FLASH_GET_PAGE_INFO_BY_IDX);
	}
#endif
	compiler_barrier();
	return z_impl_flash_get_page_info_by_idx(dev, page_index, info);
}


extern size_t z_impl_flash_get_page_count(struct device * dev);
static inline size_t flash_get_page_count(struct device * dev)
{
#ifdef CONFIG_USERSPACE
	if (z_syscall_trap()) {
		return (size_t) z_arch_syscall_invoke1(*(u32_t *)&dev, K_SYSCALL_FLASH_GET_PAGE_COUNT);
	}
#endif
	compiler_barrier();
	return z_impl_flash_get_page_count(dev);
}


extern size_t z_impl_flash_get_write_block_size(struct device * dev);
static inline size_t flash_get_write_block_size(struct device * dev)
{
#ifdef CONFIG_USERSPACE
	if (z_syscall_trap()) {
		return (size_t) z_arch_syscall_invoke1(*(u32_t *)&dev, K_SYSCALL_FLASH_GET_WRITE_BLOCK_SIZE);
	}
#endif
	compiler_barrier();
	return z_impl_flash_get_write_block_size(dev);
}


#ifdef __cplusplus
}
#endif

#pragma GCC diagnostic pop

#endif
#endif /* include guard */
